extern "C"{
    #include "ftapi.h"
    #include "ftlmetamarket.h"
};

#include <pthread.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include <windows.h>
#include <WinSock.h>

#define FILE_LINE_LEN 80
#define CSTR_BUF_LEN 256
#define GIDPFILTER_TYPE 1

extern FTRevision appVer;
extern unsigned long applSign;

typedef int (*EvalConditionFunction)(void *ud);

typedef struct{
    long open_conv_ResultCode;
    long ConversationID;
}FTConversation_DESC_REC, *FTConversation_DESC_PTR;

typedef struct {
    unsigned long classVersion;
    FTTimeStamp TS;
}ClassPositionRec, *ClassPositionPtr;

typedef struct{
    char                            host            [CSTR_BUF_LEN];
    unsigned int                    host_port;
    char                            ftoperator      [CSTR_BUF_LEN];
    char                            password        [CSTR_BUF_LEN];
    char                            license_file    [CSTR_BUF_LEN];
    char                            service_name    [CSTR_BUF_LEN];
    FTUserTypeEnum					UserType;
    FTOpenConversResProc			OpenResProc;
    FTNotifyBrokenProc				BrokenProc;
}FTAPI_CONF_REC, *FTAPI_CONF_PTR;


/***************************************************************************
*  functions
**************************************************************************/

int     LoadConfig                  (int argc, char *argv[], FTAPI_CONF_PTR conf);
int     LoadConfigByFile            (FTAPI_CONF_PTR conf, char *filename);
int     LoadConfigByFile            (FTAPI_CONF_PTR conf);
long    InitializeFTAPI             (FTAPI_CONF_PTR conf, FTContext ft_ctx);
long    ConnectToServer             (FTAPI_CONF_PTR conf, FTContext ft_ctx, unsigned int reqid);
void    FTRunCycleUntilCondition    (EvalConditionFunction condition, void *ud);
void    TransactionID_ToString      (FTTransactionID *txid, char *stxid);
void    Dump_TX_Res_Info            (long conversationID, unsigned long ReqID, FTSendTransactionResStruct *resStruct, char *desc);
void    ResetClassPosition          (ClassPositionPtr cp);
void    PrintClassPosition          (ClassPositionPtr cp);
int     LoadClassPosition           (char *filename, ClassPositionPtr cp);
int     SaveClassPosition           (char *filename, const ClassPositionPtr cp);
void    UpdateVersion               (unsigned long NewVersion, ClassPositionPtr cp);
void    UpdateTimeStamp             (FTTimeStamp NewTS, ClassPositionPtr cp);
int     IsCommentLine               (const char *line);
int     IsBlankLine                 (const char *line);
