/*******************************************************************************
publinfo.cpp

example of the usage of APPFILTER for R3/ASIA platforms.

*******************************************************************************/


#include "ftsome.h"

FTRevision appVer = {1,0,0};
unsigned long applSign = 732;

FTContext ft_ctx = NULL;
FTAPI_CONF_REC conf = {0};

//METAMARKET CONNECTION DESCRIPTOR
FTConversation_DESC_REC mm_conv_desc;

/***************************************************************************
*  Input Thread
**************************************************************************/

static int sub_done = 0;
static int my_ftsecid_read = 0;
static char ftsecid[FT_C_SEC_LEN + 1];
FT_C_REQUEST_CODEEnum req_code = EEFT_C_REQUEST_CODE;

pthread_attr_t *input_thread_attr_;
pthread_t input_thread_;


static void* input_thread_run_req_info(void *arg){
    while(1){
        if(sub_done && !my_ftsecid_read){
            printf("\n>>>> insert FTSECID for witch you want to receive public info\n");
            scanf ("%s", ftsecid);
            my_ftsecid_read = 1;
        }else if(my_ftsecid_read){
            printf("\n0 - FT_C_REQUEST_CODE_Security4Section [DO NOT USE]\n"
		            "1 - FT_C_REQUEST_CODE_SecurityInfo      [-- SUBSCRIBE --]\n"
		            "2 - FT_C_REQUEST_CODE_Depth             [DO NOT USE]\n"
		            "3 - FT_C_REQUEST_CODE_Book              [DO NOT USE]\n"
		            "4 - FT_C_REQUEST_CODE_Best              [DO NOT USE]\n"
		            "5 - FT_C_REQUEST_CODE_Order             [DO NOT USE]\n"
		            "6 - FT_C_REQUEST_CODE_Fill              [DO NOT USE]\n"
		            "7 - FT_C_REQUEST_CODE_Starting          [DO NOT USE]\n"
		            "8 - FT_C_REQUEST_CODE_Start             [DO NOT USE]\n"
		            "9 - FT_C_REQUEST_CODE_All               [DO NOT USE]\n"
                    "10 - FT_C_REQUEST_CODE_Unsub            [-- UNSUBSCRIBE --]\n"
		            "11 - FT_C_REQUEST_CODE_UnsubDepth       [DO NOT USE]\n"
		            "12 - FT_C_REQUEST_CODE_UnsubBook        [DO NOT USE]\n"
		            "13 - FT_C_REQUEST_CODE_SubExt           [DO NOT USE]\n\n");

            printf("\n>>>> type REQ-CODE TYPE\n");
            scanf ("%d", &req_code);
            Sleep(1000);
        }else{
            Sleep(1000);
        }
    }
    return 0;
}

int start_input_thread_req_info(){
    return pthread_create(&input_thread_, input_thread_attr_, input_thread_run_req_info, NULL);
}

static int req_topic_params_read = 0;
char exchange[FT_C_EXCHANGE_LEN];
char market[FT_C_MARKET_LEN];
char section[FT_C_SECTION_LEN]; 

static void* input_thread_run_req_topic(void *arg){
    while(1){
        if(sub_done && !req_topic_params_read){
            printf("\n>>>> Insert EXCHANGE / MARKET / SECTION \n");
            scanf ("%s", exchange);
            scanf ("%s", market);
            scanf ("%s", section);
            req_topic_params_read = 1;
        }else{
            Sleep(1000);
        }
    }
    return 0;
}

int start_input_thread_req_topic(){
    return pthread_create(&input_thread_, input_thread_attr_, input_thread_run_req_topic, NULL);
}



////////////////////////////////SECURITY REQUEST INFO////////////////////////////////////////

static void TransactionResProc(long	conversationID, unsigned long ReqID, FTSendTransactionResStruct *resStruct){
    Dump_TX_Res_Info(conversationID, ReqID, resStruct, "REQ-INFO");

    if(resStruct->TransactionStatus==FTTransConversationClosed){
        FTTraceAppl(FTLevel_Normal, "WARNING: Transaction response lost.");
    }
}

static void doRequestSecInfo(FT_C_REQUEST_CODEEnum ReqCode){
    FT_C_REQUEST_INFORec req;
    FTTransactionID TransactionID;
    long res = 0;
    memset(&req,0,sizeof(req));

    strcpy(req.Securities[0].SecurityID, ftsecid);

    req.NSecurities = 1;
    req.ReqCode = ReqCode;

    res = FTMakeTransactionIDExt (mm_conv_desc.ConversationID, FT_C_REQUEST_INFO_ID, &TransactionID);
    
    FTTraceAppl(FTLevel_Normal, "FTMakeTransactionIDExt [%s]", FTGetErrorString(res));

    res = FTSendTransactionExt(mm_conv_desc.ConversationID,
                                &TransactionID,
                                FTEntityADD,
                                FT_C_REQUEST_INFO_ID,
                                1,
                                &req,
                                TransactionResProc,
                                FTFalse,
                                0, 555);

    FTTraceAppl(FTLevel_Normal, "FTSendTransactionExt [%s]", FTGetErrorString(res));
}

static void doRequestTopic(FT_C_REQUEST_CODEEnum ReqCode){
    FT_C_REQUEST_TOPICRec req;
    FTTransactionID TransactionID;
    long res = 0;
    memset(&req,0,sizeof(req));

    strcpy(req.ExchangeID, exchange);
    strcpy(req.MarketID, market);
    strcpy(req.SectionID, section);

    req.ReqCode = ReqCode;

    res = FTMakeTransactionIDExt (mm_conv_desc.ConversationID, FT_C_REQUEST_TOPIC_ID, &TransactionID);
    
    FTTraceAppl(FTLevel_Normal, "FTMakeTransactionIDExt [%s]", FTGetErrorString(res));

    res = FTSendTransactionExt(mm_conv_desc.ConversationID,
                                &TransactionID,
                                FTEntityADD,
                                FT_C_REQUEST_TOPIC_ID,
                                1,
                                &req,
                                TransactionResProc,
                                FTFalse,
                                0, 487);

    FTTraceAppl(FTLevel_Normal, "FTSendTransactionExt [%s]", FTGetErrorString(res));

}


////////////////////////////////APPLICATION LOGIC ON SUBSCRIBED CLASSES ////////////////////////////////////////

long handleFT_C_SECURITY(long ConversationID, unsigned long ReqID, FTEventTypeEnum EventType, FTNotifySubscribeResStruct *ResStruct){
    FT_C_SECURITYPtr sec = (FT_C_SECURITYPtr)ResStruct->MarketObject;
    switch (ResStruct->EntityAction) {
        case FTEntityKIL:
            if (ResStruct->KeyID <= 0 && !ResStruct->MarketObject){
                // This means a class reset at the server level.
                // Every entity received previously have to be invalidated!
                FTTraceAppl(FTLevel_Normal, "FTEntityKIL Action - Class Reset Signal - New version: %d", (ResStruct->TimeStamp)[0]);
            }
            else{
                FTTraceAppl(FTLevel_Normal, "FTEntityKIL Action - KeyID [%d]", ResStruct->KeyID);
            }
            break;
        case FTEntityDEL:
            FTTraceAppl(FTLevel_Normal, "EntityDEL Action - KeyID [%d]", ResStruct->KeyID);
            break;
        case FTEntityADD:
        case FTEntityRWT:
            FTTraceAppl(FTLevel_Normal, "EntityADD/RWT Action - KeyID [%d]", ResStruct->KeyID);
            FTTraceAppl(FTLevel_Normal, "FT_C_SECURITY [ISIN:%s] [CLOSING PRICE:%f]", sec->ISINCode, sec->ClosingPrice);
            break;
    }
    return 0;
}

long handleFT_C_SECURITY_STATE(long ConversationID, unsigned long ReqID, FTEventTypeEnum EventType, FTNotifySubscribeResStruct *ResStruct){
    FT_C_SECURITY_STATEPtr sec = (FT_C_SECURITY_STATEPtr)ResStruct->MarketObject;
    switch (ResStruct->EntityAction) {
        case FTEntityKIL:
            if (ResStruct->KeyID <= 0 && !ResStruct->MarketObject){
                // This means a class reset at the server level.
                // Every entity received previously have to be invalidated!
                FTTraceAppl(FTLevel_Normal, "FTEntityKIL Action - Class Reset Signal - New version: %d", (ResStruct->TimeStamp)[0]);
            }
            else{
                FTTraceAppl(FTLevel_Normal, "FTEntityKIL Action - KeyID [%d]", ResStruct->KeyID);
            }
            break;
        case FTEntityDEL:
            FTTraceAppl(FTLevel_Normal, "EntityDEL Action - KeyID [%d]", ResStruct->KeyID);
            break;
        case FTEntityADD:
        case FTEntityRWT:
            FTTraceAppl(FTLevel_Normal, "EntityADD/RWT Action - KeyID [%d]", ResStruct->KeyID);
            FTTraceAppl(FTLevel_Normal, "FT_C_SECURITY_STATE [PHASE:%s] [DESC:%s]", sec->Phase == FT_C_TRADING_PHASE_TRADING ? "NEG" : "OTH", sec->PhaseDescription);
            break;
    }
    return 0;
}

long handleFT_C_SECURITY_EXT(long ConversationID, unsigned long ReqID, FTEventTypeEnum EventType, FTNotifySubscribeResStruct *ResStruct){
    FT_C_SECURITY_EXTPtr sec = (FT_C_SECURITY_EXTPtr)ResStruct->MarketObject;
    switch (ResStruct->EntityAction) {
        case FTEntityKIL:
            if (ResStruct->KeyID <= 0 && !ResStruct->MarketObject){
                // This means a class reset at the server level.
                // Every entity received previously have to be invalidated!
                FTTraceAppl(FTLevel_Normal, "FTEntityKIL Action - Class Reset Signal - New version: %d", (ResStruct->TimeStamp)[0]);
            }
            else{
                FTTraceAppl(FTLevel_Normal, "FTEntityKIL Action - KeyID [%d]", ResStruct->KeyID);
            }
            break;
        case FTEntityDEL:
            FTTraceAppl(FTLevel_Normal, "EntityDEL Action - KeyID [%d]", ResStruct->KeyID);
            break;
        case FTEntityADD:
        case FTEntityRWT:
            FTTraceAppl(FTLevel_Normal, "EntityADD/RWT Action - KeyID [%d]", ResStruct->KeyID);
            FTTraceAppl(FTLevel_Normal, "FT_C_SECURITY_EXT [LST PRICE:%f] [CLOSING LST PRICE:%f]", sec->LastPrice, sec->ClosureLastTradePrice);
            break;
    }
    return 0;
}

long handleFT_C_DEPTH(long ConversationID, unsigned long ReqID, FTEventTypeEnum EventType, FTNotifySubscribeResStruct *ResStruct){
    FT_C_DEPTHPtr obj = (FT_C_DEPTHPtr)ResStruct->MarketObject;
    switch (ResStruct->EntityAction) {
        case FTEntityKIL:
            if (ResStruct->KeyID <= 0 && !ResStruct->MarketObject){
                // This means a class reset at the server level.
                // Every entity received previously have to be invalidated!
                FTTraceAppl(FTLevel_Normal, "FTEntityKIL Action - Class Reset Signal - New version: %d", (ResStruct->TimeStamp)[0]);
            }
            else{
                FTTraceAppl(FTLevel_Normal, "FTEntityKIL Action - KeyID [%d]", ResStruct->KeyID);
            }
            break;
        case FTEntityDEL:
            FTTraceAppl(FTLevel_Normal, "EntityDEL Action - KeyID [%d]", ResStruct->KeyID);
            break;
        case FTEntityADD:
        case FTEntityRWT:
            FTTraceAppl(FTLevel_Normal, "EntityADD/RWT Action - KeyID [%d]", ResStruct->KeyID);
            FTTraceAppl(FTLevel_Normal, "FT_C_DEPTH [BID QTY:%f BID PR:%f] [ASK QTY:%f ASK PR:%f]", obj->Bid[0].Qty, obj->Bid[0].Price, obj->Ask[0].Qty, obj->Ask[0].Price);
            break;
    }
    return 0;
}

long handleFT_C_BOOK(long ConversationID, unsigned long ReqID, FTEventTypeEnum EventType, FTNotifySubscribeResStruct *ResStruct){
    FT_C_BOOKPtr obj = (FT_C_BOOKPtr)ResStruct->MarketObject;
    switch (ResStruct->EntityAction) {
        case FTEntityKIL:
            if (ResStruct->KeyID <= 0 && !ResStruct->MarketObject){
                // This means a class reset at the server level.
                // Every entity received previously have to be invalidated!
                FTTraceAppl(FTLevel_Normal, "FTEntityKIL Action - Class Reset Signal - New version: %d", (ResStruct->TimeStamp)[0]);
            }
            else{
                FTTraceAppl(FTLevel_Normal, "FTEntityKIL Action - KeyID [%d]", ResStruct->KeyID);
            }
            break;
        case FTEntityDEL:
            FTTraceAppl(FTLevel_Normal, "EntityDEL Action - KeyID [%d]", ResStruct->KeyID);
            break;
        case FTEntityADD:
        case FTEntityRWT:
            FTTraceAppl(FTLevel_Normal, "EntityADD/RWT Action - KeyID [%d]", ResStruct->KeyID);
            FTTraceAppl(FTLevel_Normal, "FT_C_BOOK [BID QTY:%f BID PR:%f] [ASK QTY:%f ASK PR:%f]", obj->Bid[0].Qty, obj->Bid[0].Price, obj->Ask[0].Qty, obj->Ask[0].Price);
            break;
    }
    return 0;
}

long handleFT_C_OFFICIAL_PRICE(long ConversationID, unsigned long ReqID, FTEventTypeEnum EventType, FTNotifySubscribeResStruct *ResStruct){
    FT_C_OFFICIAL_PRICEPtr obj = (FT_C_OFFICIAL_PRICEPtr)ResStruct->MarketObject;
    switch (ResStruct->EntityAction) {
        case FTEntityKIL:
            if (ResStruct->KeyID <= 0 && !ResStruct->MarketObject){
                // This means a class reset at the server level.
                // Every entity received previously have to be invalidated!
                FTTraceAppl(FTLevel_Normal, "FTEntityKIL Action - Class Reset Signal - New version: %d", (ResStruct->TimeStamp)[0]);
            }
            else{
                FTTraceAppl(FTLevel_Normal, "FTEntityKIL Action - KeyID [%d]", ResStruct->KeyID);
            }
            break;
        case FTEntityDEL:
            FTTraceAppl(FTLevel_Normal, "EntityDEL Action - KeyID [%d]", ResStruct->KeyID);
            break;
        case FTEntityADD:
        case FTEntityRWT:
            FTTraceAppl(FTLevel_Normal, "EntityADD/RWT Action - KeyID [%d]", ResStruct->KeyID);
            FTTraceAppl(FTLevel_Normal, "FT_C_OFFICIAL_PRICE ****%@%@%@%@%@%@%@**** [%f]", obj->ClosingPrice);
            break;
    }
    return 0;
}


/////////////////////////////////SUBSCRIPTION CALLBACKS////////////////////////////////////////

static void NotifyClass(long ConversationID, unsigned long ReqID, FTEventTypeEnum EventType, FTNotifySubscribeResStruct *ResStruct){
    switch(EventType){
    case FTConnectionBroken:
        FTTraceAppl(FTLevel_Error, "onMMSubscribeNotify: connection broken (%d,%d)" , ConversationID, ReqID);
        break;
    case FTClassIdle:
        FTTraceAppl(FTLevel_Normal, "idle received on class %d", ResStruct->ClassID);
        break;
    case FTClassInstance: {
            switch(ResStruct->ClassID){
                case FT_C_SECURITY_ID:
                    handleFT_C_SECURITY(ConversationID, ReqID, EventType, ResStruct);
                    break;
                case FT_C_SECURITY_STATE_ID:
                    handleFT_C_SECURITY_STATE(ConversationID, ReqID, EventType, ResStruct);
                    break;
                case FT_C_SECURITY_EXT_ID:
                    handleFT_C_SECURITY_EXT(ConversationID, ReqID, EventType, ResStruct);
                    break;
                case FT_C_DEPTH_ID:
                    handleFT_C_DEPTH(ConversationID, ReqID, EventType, ResStruct);
                    break;
                case FT_C_BOOK_ID:
                    handleFT_C_BOOK(ConversationID, ReqID, EventType, ResStruct);
                    break;
                case FT_C_OFFICIAL_PRICE_ID:
                    handleFT_C_OFFICIAL_PRICE(ConversationID, ReqID, EventType, ResStruct);
                    break;
                default:
                    break;
            }
        }
    default:
        break;
    }
}

static void SubscribeResProc(long convID, unsigned long ReqID, long ResultCode, FTSubscribeResStruct *resStruct){
    FTTraceAppl(FTLevel_Normal, "-------- FTOpenSubscribeResProc: classID [%lu], SubscriptionID [%lu]", resStruct->ClassID, resStruct->SubscriptionID);
    FTTraceAppl(FTLevel_Normal, "-------- Result: %s", FTGetErrorString(ResultCode));

    if (ResultCode == FTOK){
        FTTraceAppl(FTLevel_Normal, "-------- Status: %s", (resStruct->SubscribeStatus==FTSubscribeStart)? "Start" : "Stop");
        FTTraceAppl(FTLevel_Normal, "-------- New Table version: %lu; To-Reset signal: %d", resStruct->ClassVersion, resStruct->ResetClass);

        if (resStruct->ResetClass){
            // In this case your request can't be served in incremental manner!
            // Any previous record received have to be considered invalidated and
            // the server will resend all the class content.
            FTTraceAppl(FTLevel_Normal, "-------- Class Reset - Class %d: New version [%lu]", resStruct->ClassID, resStruct->ClassVersion);
        }
    }
}


/////////////////////////////////SUBSCR////////////////////////////////////////

long subscribe(long ConversationID){
    long res = 0;

    FTTraceAppl(FTLevel_Normal, "subscribing FT_C_SECURITY class..");
    
    res = FTStartSubscribeClassExt(ConversationID, 
                                    FTAckUnrequired,
                                    FTFlowLast,
                                    FT_C_SECURITY_ID,
                                    0, 0,
                                    FTQueryOnTime,
                                    FT_C_SECURITYKey,
                                    0, 0,
                                    SubscribeResProc,
                                    NotifyClass,
                                    777, 0, 0);

    
    FTTraceAppl(FTLevel_Normal, "subscribing FT_C_SECURITY_STATE class..");

    res = FTStartSubscribeClassExt(ConversationID,
                                    FTAckUnrequired,
                                    FTFlowLast,
                                    FT_C_SECURITY_STATE_ID,
                                    0, 0, 
                                    FTQueryOnTime,
                                    FT_C_SECURITY_STATEKey,
                                    0, 0,
                                    SubscribeResProc, NotifyClass,
                                    888, 0, 0);

    FTTraceAppl(FTLevel_Normal, "subscribing FT_C_SECURITY_EXT class..");
    
    res = FTStartSubscribeClassExt(ConversationID,
                                    FTAckUnrequired,
                                    FTFlowLast,
                                    FT_C_SECURITY_EXT_ID,
                                    0, 0, 
                                    FTQueryOnTime,
                                    FT_C_SECURITY_EXTKey,
                                    0, 0,
                                    SubscribeResProc, NotifyClass,
                                    999, 0, 0);

    FTTraceAppl(FTLevel_Normal, "subscribing FT_C_DEPTH class..");

    res = FTStartSubscribeClassExt(ConversationID,
                                    FTAckUnrequired,
                                    FTFlowLast,
                                    FT_C_DEPTH_ID,
                                    0, 0, 
                                    FTQueryOnTime,
                                    FT_C_DEPTHKey,
                                    0, 0,
                                    SubscribeResProc, NotifyClass,
                                    444, 0, 0);

    FTTraceAppl(FTLevel_Normal, "subscribing FT_C_BOOK class..");

    res = FTStartSubscribeClassExt(ConversationID,
                                    FTAckUnrequired,
                                    FTFlowLast,
                                    FT_C_BOOK_ID,
                                    0, 0, 
                                    FTQueryOnTime,
                                    FT_C_BOOKKey,
                                    0, 0,
                                    SubscribeResProc,
                                    NotifyClass,
                                    111, 0, 0);

    FTTraceAppl(FTLevel_Normal, "subscribing FT_C_OFFICIAL_PRICE class..");

    res = FTStartSubscribeClassExt(ConversationID, 
                                    FTAckUnrequired,
                                    FTFlowLast,
                                    FT_C_OFFICIAL_PRICE_ID,
                                    0,
                                    0,
                                    FTQueryOnTime,
                                    0,
                                    0, 0,
                                    SubscribeResProc,
                                    NotifyClass,
                                    211, 0, 0);

    return res;
}


/////////////////////////////////MM OPEN-CONV CALLBACKS////////////////////////////////////////
void MMOpenConvCallback(long ConversationID, long ResultCode, FTOpenResStruct *ResStruct){
    long res = 0;
    if((mm_conv_desc.open_conv_ResultCode = ResultCode) == FTOK){
        FTTraceAppl(FTLevel_Normal, "MMOpenConvCallback: MetaMarket connection is ON!");
        FTTraceAppl(FTLevel_Normal, "MMOpenConvCallback: Market Revision: V:%d.%d.%d",   
            ResStruct->MarketRevision[0],
            ResStruct->MarketRevision[1],
            ResStruct->MarketRevision[2]);

        mm_conv_desc.ConversationID = ConversationID;

        subscribe(ConversationID);
        sub_done = 1;
   }else{
        FTTraceAppl(FTLevel_Normal, "metamarket connection FAILED! (%d)", ResultCode);
        if(ResultCode == FTInvalidCID){
            FTTraceAppl(FTLevel_Normal, "CID was already used on platform we try to connect with another one..");
                if((res = ConnectToServer(&conf, ft_ctx, 999)) < 0){
                FTTraceAppl(FTLevel_Normal, "ConnectToServer failed [result: %d] program exiting..", res);
                //error
                FTShutdown();
                exit(-1);
            }
        }
    }
}

void MMBrokenConvCallback(long ConversationID, FTBrokenTypeEnum BrokenType){
    FTTraceAppl(FTLevel_Error, "MMBrokenConvCallback: metamarket connection broken (%d, %d)" , ConversationID, BrokenType);
}

int main_cho = 0;

/////////////////////////////////MAIN////////////////////////////////////////
int main(int argc, char *argv[]){
    long result = FTOK;

    if(LoadConfigByFile(&conf)){
        printf("PARAMETERS ERROR! exiting..\n");
        return 1;
    }

    //create an ft-context and set its properties
    ft_ctx = FTCreateContext();
    FTSetContextAttribute(ft_ctx, CTX_COMPRESSED, "ZIP");
    FTSetContextAttribute(ft_ctx, CTX_APPL_AUTHFILE, conf.license_file);

    //initialize ft-framework
    if(InitializeFTAPI(&conf, ft_ctx) != FTOK){
        //error
        FTShutdown();
        return 1;
    }

    conf.OpenResProc = MMOpenConvCallback;
    conf.BrokenProc = MMBrokenConvCallback;
    conf.UserType = FTUserTrader;

    printf("\n>>>> Type 1 to send FT_C_REQUEST_INFO or 2 to send FT_C_REQUEST_TOPIC\n");
    scanf("%d", &main_cho);
    if(main_cho != 1 && main_cho != 2){
        printf("\nbad input.. exiting.\n");
        FTShutdown();
        return 1;
    }

    //remember that connection will not be done until you call at least one FTRun() call.
    if(ConnectToServer(&conf, ft_ctx, 999) < 0){
        //error
        FTShutdown();
        return 1;
    }

    if(main_cho == 1){
        start_input_thread_req_info();
    }else{
        start_input_thread_req_topic();
    }


/***********************************************************************************
** MAIN EVENT LOOP **
 Calling FTRun() ensures that all requests (subscriptions, transactions, queries ..) 
 will be handled by FTAPI durig program lifecycle.
***********************************************************************************/
    unsigned long times = 0; 
    do{
        if(FTRun() != FTOK){
            FTShutdown();
            return 1;
        }
        times++;
        if(!(times % 10)){
            FTTraceAppl(FTLevel_Full, "FTRun called %lu times", times);
        }
        FTSocketSelect();

        if(my_ftsecid_read && req_code != EEFT_C_REQUEST_CODE){
            FTTraceAppl(FTLevel_Normal, "sending request info for security: [%s] TYPE[ %d ]", ftsecid, req_code);
            doRequestSecInfo(req_code);
            req_code = EEFT_C_REQUEST_CODE;
        }else if(req_topic_params_read){
            FTTraceAppl(FTLevel_Normal, "sending request topic for exchange: [%s] market: [%s] section: [%s]", exchange, market, section);
            doRequestTopic(req_code);
            req_code = EEFT_C_REQUEST_CODE;
        }

    }while(1);

    //unreachable code
    return 0;
}

